#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "gequel.h"

char * add_cwd(char *preset)
{
   char *currentdir;
   static char abspath[2048];
   
   currentdir = getcwd(NULL,0); /* store current working directory */

   ldebug (2,"add_cwd entered (cwd: %s) \n",currentdir);
   
   if(preset[0] != '/')
     snprintf(abspath,sizeof(abspath) -1,"%s/%s",currentdir,preset);
   else
     snprintf(abspath,sizeof(abspath) -1,"%s",preset);
   
   free(currentdir); /* release memory space allocated by getcwd (Gnu) */
   return abspath;
}

char * strip_cwd(char *choice)
{
   char *currentdir;
   char *truncateddir;
   
   currentdir = getcwd(NULL,0); /* store current working directory */
   
   ldebug (2,"strip_cwd entered (cwd: %s) \n",currentdir);
   
   truncateddir = strstr(choice,currentdir);
   if(choice == truncateddir) //pointers are equal
   {
      if( strlen(currentdir) == strlen(choice) )
	choice = ".";
      else
	choice += strlen(currentdir) + 1;
   }
   
   free(currentdir); /* release memory space allocated by getcwd (Gnu) */
   return choice;
}

void newFileSelector(char *preset, char **result, GtkFileChooserAction action )
{
   GtkWidget *fsel;

   ldebug(1,"newFileSelector entered\n");
   ldebug(2,"newFileSelector: result=%ld\n", result);
   
   *result = NULL; /* clear possible leftover from previous call */
   
   fsel = gtk_file_chooser_dialog_new ("Choose directory",
				       GTK_WINDOW(getTopWindow()),
				       action,
				       GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				       GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				       NULL);

   switch(action)
   {
    case GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER :
    case GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER :
      gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (fsel), add_cwd(preset));
      break;
    case GTK_FILE_CHOOSER_ACTION_SAVE :
      gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (fsel), preset);
    default :
      gtk_file_chooser_set_filename( GTK_FILE_CHOOSER (fsel), add_cwd(preset));
      break;
   }
   
   if (gtk_dialog_run (GTK_DIALOG (fsel)) == GTK_RESPONSE_ACCEPT)
     *result = strip_cwd((gchar *)
			 gtk_file_chooser_get_filename(GTK_FILE_CHOOSER (fsel)));
   else
     *result = preset;
   
   gtk_widget_destroy (fsel);
   
   ldebug(2,"storeNameAction: result=%ld (%s)\n", result, *result);
}

